Unit AER6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER6R(NM :Integer; N :Integer; var AR :Array of Real;
                var AI :Array of Real; var TAU :Array of Real;
                M :Integer; var ZR :Array of Real;
                var ZI :Array of Real);

implementation

procedure AER6R(NM :Integer; N :Integer; var AR :Array of Real;
                var AI :Array of Real; var TAU :Array of Real;
                M :Integer; var ZR :Array of Real;
                var ZI :Array of Real);
var
I,J,K,L :Integer;
H,S,SI :Real;
label
_1,_2,_3,_4,_5,_6;
begin
if ( M = 0 ) 
 then goto _6;
{  ********** }
for K:=1 to N do
 begin
  for J:=1 to M do
   begin
    ZI[(K-1)+(J-1)*NM] := -ZR[(K-1)+(J-1)*NM]*TAU[1+(K-1)*2];
    ZR[(K-1)+(J-1)*NM] := ZR[(K-1)+(J-1)*NM]*TAU[0+(K-1)*2];
_1:
   end;
 end;
if ( N = 1 ) 
 then goto _6;
{  ********** }
for I:=2 to N do
 begin
  L := I-1;
  H := AI[(I-1)+(I-1)*NM];
  if ( H = 0.0 ) 
   then goto _5;
  for J:=1 to M do
   begin
    S := 0.0;
    SI := 0.0;
    for K:=1 to L do
     begin
      S := S+AR[(I-1)+(K-1)*NM]*ZR[(K-1)+(J-1)*NM]-AI[(I-1)+(K-1)*NM]*ZI[(K-1)+(J-1)*NM];
      SI := SI+AR[(I-1)+(K-1)*NM]*ZI[(K-1)+(J-1)*NM]+AI[(I-1)+(K-1)*NM]*ZR[(K-1)+(J-1)*NM];
_2:
     end;
    S := (S/H)/H;
    SI := (SI/H)/H;
    for K:=1 to L do
     begin
      ZR[(K-1)+(J-1)*NM] := ZR[(K-1)+(J-1)*NM]-S*AR[(I-1)+(K-1)*NM]-SI*AI[(I-1)+(K-1)*NM];
      ZI[(K-1)+(J-1)*NM] := ZI[(K-1)+(J-1)*NM]-SI*AR[(I-1)+(K-1)*NM]+S*AI[(I-1)+(K-1)*NM];
_3:
     end;
_4:
   end;
_5:
 end;
_6:
end;

end.
